version: "3.8"

services:
  auth-service:
    image: mihaialinsendre/web_crawler_auth
    environment:
      NODE_ENV: development
    ports:
      - 8003:5002
    networks:
      - internal
    deploy:
      placement:
        constraints: [node.role == manager]
      replicas: 3
      update_config:
        parallelism: 2
        delay: 10s
      restart_policy:
        condition: on-failure
  
  web-crawler-service:
    image: mihaialinsendre/web_crawler_api
    environment:
      NODE_ENV: development
    ports:
      - 8001:5001
    networks:
      - internal
      - web-crawler 
    deploy:
      replicas: 3
      update_config:
        parallelism: 2
        delay: 10s
      restart_policy:
        condition: on-failure

  io-service:
    image: mihaialinsendre/web_crawler_ioservice
    environment:
      NODE_ENV: development
    ports:
      - 8002:5000
    networks:
      - web-crawler
    deploy:
      placement:
        constraints: [node.role == manager]
      replicas: 3
      update_config:
        parallelism: 2
        delay: 10s
      restart_policy:
        condition: on-failure

  visualizer:
    image: dockersamples/visualizer:stable
    ports:
      - 8081:8080
    stop_grace_period: 1m30s
    volumes:
      - "/var/run/docker.sock:/var/run/docker.sock"
    deploy:
      placement:
        constraints: [node.role == manager]

  kong:
    image: kong:latest
    volumes:
      - ./kong:/usr/kong
    environment:
      KONG_DATABASE: "off"
      KONG_DECLARATIVE_CONFIG: /usr/kong/kong.yml
      KONG_PROXY_ACCESS_LOG: /dev/stdout
      KONG_ADMIN_ACCESS_LOG: /dev/stdout
      KONG_PROXY_ERROR_LOG: /dev/stderr
      KONG_ADMIN_ERROR_LOG: /dev/stderr
      KONG_ADMIN_LISTEN: 0.0.0.0:8001, 0.0.0.0:8444 ssl
    ports:
      - 80:8000
      - 443:8443
    deploy:
      placement:
        constraints: [node.role == manager]
    networks:
      - internal

networks:
  internal:
  web-crawler:
